#ifndef _MRM_IVCP_ALARM_H
#define _MRM_IVCP_ALARM_H

#include "ivcp/library.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
	unsigned short year;		
	unsigned char month;
	unsigned char day;
	unsigned char hour;
	unsigned char minute;
	unsigned char second;
	unsigned char week;
} ivcp_alarm_real_time_t;

typedef struct
{		
	unsigned char day_of_week;
	unsigned char hour;
	unsigned char minute;
} ivcp_alarm_wakeup_time_t;

typedef enum ivcp_alarm_mode
{
	IVCP_ALARM_MODE_NO_ALARM = -1,
	IVCP_ALARM_MODE_HOURLY = 0,
	IVCP_ALARM_MODE_DAILY,
	IVCP_ALARM_MODE_WEEKLY
} ivcp_alarm_mode;

IVCP_API mrm_err ivcp_alarm_get_real_time(ivcp_alarm_real_time_t *real_time);
IVCP_API mrm_err ivcp_alarm_set_real_time(ivcp_alarm_real_time_t real_time);
IVCP_API mrm_err ivcp_alarm_get_wakeup_time(ivcp_alarm_wakeup_time_t *wakeup_time);
IVCP_API mrm_err ivcp_alarm_set_wakeup_time(ivcp_alarm_wakeup_time_t wakeup_time);
IVCP_API mrm_err ivcp_alarm_get_wakeup_mode(ivcp_alarm_mode *mode);
IVCP_API mrm_err ivcp_alarm_set_wakeup_mode(ivcp_alarm_mode mode);
IVCP_API mrm_err ivcp_alarm_wakeup_enable(void);
IVCP_API mrm_err ivcp_alarm_wakeup_disable(void);
IVCP_API mrm_err ivcp_alarm_get_wakeup_status(char *status);
//IVCP_API mrm_err ivcp_alarm_sync_os_time(void);
//IVCP_API mrm_err ivcp_alarm_sync_real_time(void);

#ifdef __cplusplus
}
#endif

#endif
