#ifndef _MRM_IVCP_CRADLE_H
#define _MRM_IVCP_CRADLE_H

#include "ivcp/library.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum ivcp_cradle_funkey_id
{
   IVCP_FUNCTION_KEY1 = 0,
   IVCP_FUNCTION_KEY2,
   IVCP_FUNCTION_KEY3,
   IVCP_FUNCTION_KEY4,
   IVCP_FUNCTION_KEY5,
}ivcp_cradle_funkey_id;

IVCP_API mrm_err ivcp_cradle_set_detach_event(void *cradle_event);
IVCP_API mrm_err ivcp_cradle_set_attach_event(void *cradle_event);
IVCP_API mrm_err ivcp_cradle_get_status(char *status);
IVCP_API mrm_err ivcp_cradle_set_led_brightness(unsigned char brightness);
IVCP_API mrm_err ivcp_cradle_get_led_brightness(unsigned char *brightness);
IVCP_API mrm_err ivcp_cradle_set_keycode_us(ivcp_cradle_funkey_id id,unsigned int keycode);
IVCP_API mrm_err ivcp_cradle_get_keycode_us(ivcp_cradle_funkey_id id,unsigned int *keycode);
IVCP_API mrm_err ivcp_cradle_set_keycode_hid(ivcp_cradle_funkey_id id,unsigned int keycode);
IVCP_API mrm_err ivcp_cradle_get_keycode_hid(ivcp_cradle_funkey_id id,unsigned int *keycode);

#ifdef __cplusplus
}
#endif
#endif
