#ifndef _MRM_IVCP_DIGITAL_IO_H
#define _MRM_IVCP_DIGITAL_IO_H

#include "ivcp/library.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum ivcp_dio_pin_id
{
   IVCP_DIGITAL_PIN0 = 0,
   IVCP_DIGITAL_PIN1,
   IVCP_DIGITAL_PIN2,
   IVCP_DIGITAL_PIN3,
   IVCP_DIGITAL_PIN4,
   IVCP_DIGITAL_PIN5,
   IVCP_DIGITAL_PIN6,
   IVCP_DIGITAL_PIN7,
   IVCP_DIGITAL_PIN_UPDATE = 1000
}ivcp_dio_pin_id;

typedef enum ivcp_dio_input_type {
	IVCP_DIO_INPUT_TYPE_WET_CONTACT = 0,
	IVCP_DIO_INPUT_TYPE_DRY_CONTACT,
}ivcp_dio_input_type;

typedef enum ivcp_over_current_pin_id {
	IVCP_DIO_OC_PIN_DO = 0,
	IVCP_DIO_OC_PIN_D1,
    IVCP_DIO_OC_PIN_D2,
    IVCP_DIO_OC_PIN_UPDATE_STATUS,
}ivcp_over_current_pin_id;

IVCP_API mrm_err ivcp_dio_get_input_number(char *number);
IVCP_API mrm_err ivcp_dio_get_output_number(char *number);
IVCP_API mrm_err ivcp_dio_read_input(ivcp_dio_pin_id id, char *status);
IVCP_API mrm_err ivcp_dio_read_input_multiple(unsigned int *status);
IVCP_API mrm_err ivcp_dio_write_output(ivcp_dio_pin_id id, char status);
IVCP_API mrm_err ivcp_dio_read_output(ivcp_dio_pin_id id, char *status);
IVCP_API mrm_err ivcp_dio_get_di_wakeup_status(ivcp_dio_pin_id id, char *status);
IVCP_API mrm_err ivcp_dio_di_wakeup_enable(ivcp_dio_pin_id id);
IVCP_API mrm_err ivcp_dio_di_wakeup_disable(ivcp_dio_pin_id id);
IVCP_API mrm_err ivcp_dio_get_input_type(ivcp_dio_input_type *type);
IVCP_API mrm_err ivcp_dio_set_input_type(ivcp_dio_input_type type);
IVCP_API mrm_err ivcp_dio_get_pin_input_type(ivcp_dio_pin_id id, ivcp_dio_input_type *type);
IVCP_API mrm_err ivcp_dio_set_pin_input_type(ivcp_dio_pin_id id, ivcp_dio_input_type type);
IVCP_API mrm_err ivcp_dio_get_reference_voltage(float* voltage);
IVCP_API mrm_err ivcp_dio_set_reference_voltage(float voltage);

#ifdef __cplusplus
}
#endif
#endif
