#ifndef _MRM_IVCP_GSENSOR_H
#define _MRM_IVCP_GSENSOR_H

#include "ivcp/library.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
	int x_mg;		
	int y_mg;		
	int z_mg;
} ivcp_gsensor_value_t;

typedef enum ivcp_gsensor_res
{
   IVCP_GSENSOR_RES_2G = 0,
   IVCP_GSENSOR_RES_4G,
   IVCP_GSENSOR_RES_8G,
   IVCP_GSENSOR_RES_16G
}ivcp_gsensor_res;

IVCP_API mrm_err ivcp_gsensor_available(char *supported);
IVCP_API mrm_err ivcp_gsensor_enable(void);
IVCP_API mrm_err ivcp_gsensor_disable(void);
IVCP_API mrm_err ivcp_gsensor_get_status(char *status);
IVCP_API mrm_err ivcp_gsensor_read(ivcp_gsensor_value_t *value);
IVCP_API mrm_err ivcp_gsensor_get_resolution(ivcp_gsensor_res *res);
IVCP_API mrm_err ivcp_gsensor_set_resolution(ivcp_gsensor_res res);
IVCP_API mrm_err ivcp_gsensor_wakeup_enable();
IVCP_API mrm_err ivcp_gsensor_wakeup_disable();
IVCP_API mrm_err ivcp_gsensor_get_wakeup_status(char *status);
IVCP_API mrm_err ivcp_gsensor_get_wakeup_threshold(int *mg);
IVCP_API mrm_err ivcp_gsensor_set_wakeup_threshold(int mg);
IVCP_API mrm_err ivcp_gsensor_set_alarm_event(void *gsensor_alarm_event);
IVCP_API mrm_err ivcp_gsensor_get_alarm_threshold(int *mg);
IVCP_API mrm_err ivcp_gsensor_set_alarm_threshold(int mg);
IVCP_API mrm_err ivcp_gsensor_get_alarm_data(ivcp_gsensor_value_t *value);
IVCP_API mrm_err ivcp_gsensor_get_arlarm(char *enable);
IVCP_API mrm_err ivcp_gsensor_set_arlarm(char enable);

#ifdef __cplusplus
}
#endif

#endif
