#ifndef _MRM_IVCP_LIBRARY_H
#define _MRM_IVCP_LIBRARY_H

#ifndef IVCP_API
	#if defined (_WIN32) || defined (WINCE)
		#ifdef DLL_EXPORTS
		#define IVCP_API __declspec( dllexport )
		#else
		#define IVCP_API __declspec( dllimport )
		#endif
	#elif defined (__linux__) || defined (ANDROID)
		#define IVCP_API
		#ifndef _stdcall
			#define _stdcall
		#endif
		#ifndef NULL
			#define NULL 0
		#endif
		#include <pthread.h>
		typedef struct _OSEVENT {pthread_cond_t *event_handle; pthread_mutex_t *mutex_handle;} OSEVENT;
	#else
		#error:Unknown OS
	#endif
#endif

#include "mrm_error.h"

#ifdef __cplusplus
extern "C" {

#else

typedef unsigned char bool;

#define true 1
#define false 0

#endif

#define IVCP_MAXIMUM_LIBRARY_STRING_LENGTH 24
#define IVCP_MAXIMUM_PLATFORM_STRING_LENGTH 16
#define IVCP_MAXIMUM_DEVICE_SERIAL_NUMBER_STRING_LENGTH 64
#define IVCP_MAXIMUM_PCB_VER_STR_LENGTH 12
#define IVCP_MAXIMUM_CPU_SERIAL_NUMBER_STRING_LENGTH 64

#define IVCP_VALUE_ENABLE  1
#define IVCP_VALUE_DISABLE 0

IVCP_API mrm_err ivcp_init(void);
IVCP_API mrm_err ivcp_deinit(void);
IVCP_API mrm_err ivcp_get_version(char *version);
IVCP_API mrm_err ivcp_get_platform_name(char *name);
IVCP_API mrm_err ivcp_get_device_serial_number(char *serial_number);

#ifdef __cplusplus
}
#endif

#endif
