#ifndef _MRM_IVCP_PSE_H
#define _MRM_IVCP_PSE_H

#include "ivcp/library.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum ivcp_pse_classification
{
	IVCP_PSE_CS_CLASS0 = 0,
	IVCP_PSE_CS_CLASS1 = 1,
	IVCP_PSE_CS_CLASS2 = 2,
	IVCP_PSE_CS_CLASS3 = 3,
	IVCP_PSE_CS_CLASS4 = 4,
	IVCP_PSE_CS_UNKNOWN = 1000,
	IVCP_PSE_CS_OVERCURRENT = 1001	
} ivcp_pse_classification;

typedef enum ivcp_pse_working_status
{
	IVCP_PSE_WS_GOOD = 0,
	IVCP_PSE_WS_SHORT_CIRCUIT = 1,
	IVCP_PSE_WS_OPEN_CIRCUIT = 2,
	IVCP_PSE_WS_INTERNAL_ERROR = 3,
	IVCP_PSE_WS_UNKNOWN = 4
} ivcp_pse_working_status;

IVCP_API mrm_err ivcp_pse_get_working_status(unsigned int port, ivcp_pse_working_status *status);
IVCP_API mrm_err ivcp_pse_get_classification_status(unsigned int port, ivcp_pse_classification *cs);
IVCP_API mrm_err ivcp_pse_get_power_status(unsigned int port, char *status);
IVCP_API mrm_err ivcp_pse_reset(unsigned int port);

#ifdef __cplusplus
}
#endif

#endif
