#ifndef _MRM_ERROR_H
#define _MRM_ERROR_H

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned int mrm_err;

#define MRM_ERR_NO_ERROR             (0x00000000)
#define MRM_ERR_INVALID_POINTER      (0x00000001)
#define MRM_ERR_INVALID_ARGUMENT     (0x00000002)
#define MRM_ERR_UNSUPPORT_OPERATION  (0x00000003)
#define MRM_ERR_LIBRARY_NOT_INIT     (0x00000005)
#define MRM_ERR_ILLEGAL_OPERATION    (0x00000010)
#define MRM_ERR_LIBRARY_ALREADY_INIT (0x00000011)
#define MRM_ERR_ARRAY_OUR_OF_RANGE   (0x00000012)
#define MRM_ERR_OPERATION_FAIL       (0x00000013)
#define MRM_ERR_DEVICE_NOT_EXIST     (0x00000014)

#define MRM_ERR_IVCP_DEVICE_NODE_OPEN_FAIL                 (0x01000001)
#define MRM_ERR_IVCP_DEVICE_NODE_WRITE_FAIL                (0x01000002)
#define MRM_ERR_IVCP_DEVICE_NODE_READ_FAIL                 (0x01000003)
#define MRM_ERR_IVCP_IS_BUSY                               (0x01000004)
#define MRM_ERR_IVCP_ERROR_COMMAND                         (0x01000005)
#define MRM_ERR_IVCP_ERROR_RESPONSE_FORMAT_NOT_MATCH       (0x01000006)
#define MRM_ERR_IVCP_PARAMETER_OUT_OF_RANGE                (0x01000007)
#define MRM_ERR_IVCP_DEVICE_NODE_READ_TIMEOUT              (0x01000008)
#define MRM_ERR_IVCP_NO_EEPROM_CHIP_FIND                   (0x01000009)
#define MRM_ERR_IVCP_DEVICE_NODE_WRITE_NOT_MATCH           (0x0100000A)
#define MRM_ERR_IVCP_NO_GSENSOR_CHIP_FIND                  (0x0100000B)
#define MRM_ERR_IVCP_UNKNOW_RETURN_VALUE                   (0x0100000C)
#define MRM_ERR_IVCP_GSENSOR_DATA_INVALID                  (0x0100000D)
#define MRM_ERR_IVCP_UNKNOW_ERROR_CODE                     (0x0100000E)
#define MRM_ERR_IVCP_PSENSOR_DATA_INVALID                  (0x0100000F)
#define MRM_ERR_IVCP_NO_PSENSOR_CHIP_FIND                  (0x01000010)
#define MRM_ERR_IVCP_SMBUS_ENCOUTER_ERROR                  (0x01000011)
#define MRM_ERR_IVCP_GSENSOR_DATA_NOT_READY                (0x01000012)
#define MRM_ERR_IVCP_USER_DEFAULT_IS_EMPTY                 (0x01000013)

#define MRM_ERR_SDP_DEVICE_NODE_OPEN_FAIL                  (0x02000001)
#define MRM_ERR_SDP_DEVICE_NODE_WRITE_FAIL                 (0x02000002)
#define MRM_ERR_SDP_DEVICE_NODE_READ_FAIL                  (0x02000003)
#define MRM_ERR_SDP_IS_BUSY                                (0x02000004)
#define MRM_ERR_SDP_ERROR_COMMAND                          (0x02000005)
#define MRM_ERR_SDP_ERROR_RESPONSE_FORMAT_NOT_MATCH        (0x02000006)
#define MRM_ERR_SDP_PARAMETER_OUT_OF_RANGE                 (0x02000007)
#define MRM_ERR_SDP_DEVICE_NODE_READ_TIMEOUT               (0x02000008)
#define MRM_ERR_SDP_NO_EEPROM_CHIP_FIND                    (0x02000009)
#define MRM_ERR_SDP_DEVICE_NODE_WRITE_NOT_MATCH            (0x0200000A)

#define MRM_ERR_VCIL_DEVICE_NODE_OPEN_FAIL                 (0x03000001)
#define MRM_ERR_VCIL_DEVICE_NODE_WRITE_FAIL                (0x03000002)
#define MRM_ERR_VCIL_DEVICE_NODE_READ_FAIL                 (0x03000003)
#define MRM_ERR_VCIL_IS_BUSY                               (0x03000004)
#define MRM_ERR_VCIL_ERROR_RESPONSE_FORMAT_NOT_MATCH       (0x03000006)
#define MRM_ERR_VCIL_DEVICE_NODE_READ_TIMEOUT              (0x03000008)
#define MRM_ERR_VCIL_DATA_NOT_READY                        (0x03000009)
#define MRM_ERR_VCIL_CAN_FILTER_NOT_ENABLE                 (0x03000010)

#define MRM_ERR_GPS_DEVICE_NODE_OPEN_FAIL                  (0x04000001)
#define MRM_ERR_GPS_DEVICE_NODE_WRITE_FAIL                 (0x04000002)
#define MRM_ERR_GPS_DEVICE_NODE_READ_FAIL                  (0x04000003)
#define MRM_ERR_GPS_IS_BUSY                                (0x04000004)
#define MRM_ERR_GPS_DEVICE_NODE_READ_TIMEOUT               (0x04000008)
#define MRM_ERR_GPS_DATA_NOT_READY                         (0x04000009)
#define MRM_ERR_GPS_UNKNOWN_HARDWARE                       (0x0400000A)
#define MRM_ERR_GPS_OPEN_FAIL_NO_DATA_IN                   (0x0400000B)

#define MRM_ERR_WWAN_DEVICE_NODE_OPEN_FAIL                  (0x05000001)
#define MRM_ERR_WWAN_DEVICE_NODE_WRITE_FAIL                 (0x05000002)
#define MRM_ERR_WWAN_DEVICE_NODE_READ_FAIL                  (0x05000003)
#define MRM_ERR_WWAN_IS_BUSY                                (0x05000004)
#define MRM_ERR_WWAN_DEVICE_NODE_READ_TIMEOUT               (0x05000008)
#define MRM_ERR_WWAN_NO_CARRIER                             (0x05000010)

/* Reserve 0x10000000 ~ 0x10FFFFFF for Android */
#define MRM_ERR_ANDROID_JNI_NULL_POINTER                            (0x10000001)
#define MRM_ERR_ANDROID_JNI_OUT_OF_MEMORY             	            (0x10000002)
#define MRM_ERR_ANDROID_JNI_EVENT_INIT_FAILED                       (0x10000003)
#define MRM_ERR_ANDROID_JNI_EVENT_DEINIT_FAILED                     (0x10000004)
#define MRM_ERR_ANDROID_JNI_EVENT_LISTENING_THREAD_ALREADY_RUNNING  (0x10000005)
#define MRM_ERR_ANDROID_JNI_EVENT_LISTENING_THREAD_CREATE_FAILED    (0x10000006)

#ifdef __cplusplus
}
#endif

#endif
