#ifndef _MRM_SDP_HOTKEY_H
#define _MRM_SDP_HOTKEY_H

#include "sdp/library.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
	unsigned char key[8];
} sdp_keys_value_t;

typedef void ( _stdcall *hotkey_event_callback ) ( sdp_keys_value_t *keys );

SDP_API mrm_err sdp_hotkey_read(sdp_keys_value_t *keys);
SDP_API mrm_err sdp_hotkey_get_number(int *num);
SDP_API mrm_err sdp_hotkey_set_event_callback(hotkey_event_callback callback);
SDP_API mrm_err sdp_hotkey_clear_event_callback(void);
SDP_API mrm_err sdp_hotkey_enable_callback(void);
SDP_API mrm_err sdp_hotkey_disable_callback(void);
SDP_API mrm_err sdp_hotkey_get_brightness(unsigned char *brightness );
SDP_API mrm_err sdp_hotkey_set_brightness(unsigned char brightness );

#ifdef __cplusplus
}
#endif

#endif
