#ifndef _MRM_SDP_LIBRARY_H
#define _MRM_SDP_LIBRARY_H

#ifndef SDP_API
	#if defined (_WIN32) || defined (WINCE)
		#ifdef DLL_EXPORTS
		#define SDP_API __declspec( dllexport )
		#else
		#define SDP_API __declspec( dllimport )
		#endif
	#elif defined (__linux__) || defined (ANDROID)
		#define SDP_API
		#ifndef _stdcall
			#define _stdcall
		#endif
		#ifndef NULL
			#define NULL 0
		#endif
		#include <pthread.h>
		typedef struct _OSEVENT {pthread_cond_t *event_handle; pthread_mutex_t *mutex_handle;} OSEVENT;
	#else
		#error:Unknown OS
	#endif
#endif

#include "mrm_error.h"

#ifdef __cplusplus
extern "C" {
#else

typedef unsigned char bool;

#define true 1
#define false 0

#endif

#define SDP_MAXIMUM_LIBRARY_STRING_LENGTH 24
#define SDP_MAXIMUM_PLATFORM_STRING_LENGTH 16

#define SDP_VALUE_ENABLE  1
#define SDP_VALUE_DISABLE 0

SDP_API mrm_err sdp_init(void);
SDP_API mrm_err sdp_deinit(void);
SDP_API mrm_err sdp_get_version(char *version);
SDP_API mrm_err sdp_get_platform_name(char *name);

#ifdef __cplusplus
}
#endif

#endif
