#ifndef _MRM_VCIL_J1587_H
#define _MRM_VCIL_J1587_H

#include "vcil/library.h"

#ifdef __cplusplus
extern "C" {
#endif

#define	VCIL_MAX_J1587_DATA_SIZE 20
#define VCIL_MAX_J1587_MASK_NUM 256

typedef struct
{
	unsigned char mid;
	unsigned char priority;
	unsigned int pid;	
	int length;
	unsigned char data[VCIL_MAX_J1587_DATA_SIZE];
	unsigned char port;
} vcil_j1587_message_t;

VCIL_API mrm_err vcil_j1587_read(vcil_j1587_message_t *message);
VCIL_API mrm_err vcil_j1587_write(vcil_j1587_message_t *message);
VCIL_API mrm_err vcil_j1587_add_mask(unsigned int pid);
VCIL_API mrm_err vcil_j1587_get_mask_number(unsigned int* total);
VCIL_API mrm_err vcil_j1587_get_all_mask(unsigned int* pid);
VCIL_API mrm_err vcil_j1587_remove_mask(unsigned int pid);
VCIL_API mrm_err vcil_j1587_remove_all_mask(void);
VCIL_API mrm_err vcil_j1587_set_event(void *j1587_rx_event);

#ifdef __cplusplus
}
#endif

#endif