#ifndef _MRM_VCIL_J1708_H
#define _MRM_VCIL_J1708_H

#include "vcil/library.h"

#ifdef __cplusplus
extern "C" {
#endif

#define	VCIL_MAX_J1708_DATA_SIZE 20
#define VCIL_MAX_J1708_MASK_NUM 256

typedef struct
{
	unsigned char mid;
	unsigned char priority;
	int length;
	unsigned char data[VCIL_MAX_J1708_DATA_SIZE];
	unsigned char port;
} vcil_j1708_message_t;

typedef struct
{
	unsigned int j1708_port0_recv_count;
	unsigned int j1708_port0_recv_byte;
	unsigned int j1708_port0_send_count;
	unsigned int j1708_port0_collision_err_count;
	unsigned int j1708_port0_checksum_err_count;
	unsigned int j1708_port1_recv_count;
	unsigned int j1708_port1_recv_byte;
	unsigned int j1708_port1_send_count;
	unsigned int j1708_port1_collision_err_count;
	unsigned int j1708_port1_checksum_err_count;
} vcil_j1708_stat_t;

VCIL_API mrm_err vcil_j1708_read(vcil_j1708_message_t *message);
VCIL_API mrm_err vcil_j1708_write(vcil_j1708_message_t *message);
VCIL_API mrm_err vcil_j1708_add_mask(unsigned char mid);
VCIL_API mrm_err vcil_j1708_get_mask_number(unsigned int* total);
VCIL_API mrm_err vcil_j1708_get_all_mask(unsigned char* mid);
VCIL_API mrm_err vcil_j1708_remove_mask(unsigned char mid);
VCIL_API mrm_err vcil_j1708_remove_all_mask(void);
VCIL_API mrm_err vcil_j1708_set_event(void *j1708_rx_event);
VCIL_API mrm_err vcil_j1708_get_stat(vcil_j1708_stat_t *stat);

#ifdef __cplusplus
}
#endif

#endif