#ifndef _MRM_VCIL_LIBRARY_H
#define _MRM_VCIL_LIBRARY_H

#ifndef VCIL_API
	#if defined (_WIN32) || defined (WINCE)
		#ifdef DLL_EXPORTS
		#define VCIL_API __declspec( dllexport )
		#else
		#define VCIL_API __declspec( dllimport )
		#endif
		#define OSEVENT HANDLE
	#elif defined (__linux__) || defined (ANDROID)
		#define VCIL_API
		#ifndef _stdcall
			#define _stdcall
		#endif
		#ifndef NULL
			#define NULL 0
		#endif
		
		#include <pthread.h>
		typedef struct _OSEVENT {pthread_cond_t *event_handle; pthread_mutex_t *mutex_handle;} OSEVENT;
	#else
		#error:Unknown OS
	#endif
#endif

#include "mrm_error.h"

#ifdef __cplusplus
extern "C" {
#else

typedef unsigned char bool;

#define true 1
#define false 0

#endif

#define VCIL_MAXIMUM_LIBRARY_STRING_LENGTH 24

typedef enum vcil_mode
{
	VCIL_MODE_CAN= 0,
	VCIL_MODE_J1939,
	VCIL_MODE_OBD2,
	VCIL_MODE_J1708,
	VCIL_MODE_J1587
} vcil_mode;

VCIL_API mrm_err vcil_init(char *port);
VCIL_API mrm_err vcil_deinit(void);
VCIL_API mrm_err vcil_get_version(char *version);
VCIL_API mrm_err vcil_set_mode(vcil_mode can_port0, vcil_mode can_port1, vcil_mode j1708_port0);
VCIL_API mrm_err vcil_get_mode(vcil_mode *can_port0, vcil_mode *can_port1, vcil_mode *j1708_port0);
VCIL_API mrm_err vcil_reset_stat(void);

#ifdef __cplusplus
}
#endif

#endif
