#ifndef _MRM_VCIL_OBD2_H
#define _MRM_VCIL_OBD2_H

#include "vcil/library.h"

#ifdef __cplusplus
extern "C" {
#endif

#define	VCIL_MAX_OBD2_DATA_SIZE 64
#define	VCIL_MAX_OBD2_MASK_NUM 128

#define VCIL_OBD2_TYPE_PHYSICAL       218
#define VCIL_OBD2_TAPE_FUNCTIONAL     219

typedef struct
{
	unsigned char port;
	unsigned char type;
	unsigned char destination;
	unsigned char source;
	unsigned char priority;
	int length;
	unsigned char data[VCIL_MAX_OBD2_DATA_SIZE];
} vcil_obd2_message_t;

typedef struct
{
	unsigned int obd2_port0_recv_count;
	unsigned int obd2_port0_send_count;
	unsigned int obd2_port0_fail_count;
	unsigned int obd2_port1_recv_count;
	unsigned int obd2_port1_send_count;
	unsigned int obd2_port1_fail_count;
} vcil_obd2_stat_t;

VCIL_API mrm_err vcil_obd2_read(vcil_obd2_message_t *message);
VCIL_API mrm_err vcil_obd2_write(vcil_obd2_message_t *message);
VCIL_API mrm_err vcil_obd2_add_mask(unsigned char port, unsigned int pid);
VCIL_API mrm_err vcil_obd2_get_mask_number(unsigned char port,  unsigned int* total);
VCIL_API mrm_err vcil_obd2_get_all_mask(unsigned char port, unsigned int* pid);
VCIL_API mrm_err vcil_obd2_remove_mask(unsigned char port, unsigned int pid);
VCIL_API mrm_err vcil_obd2_remove_all_mask(unsigned char port);
VCIL_API mrm_err vcil_obd2_set_event(void *obd2_rx_event);
VCIL_API mrm_err vcil_obd2_get_stat(vcil_obd2_stat_t *stat);

#ifdef __cplusplus
}
#endif

#endif