#include <stdio.h>

#include "common.h"
#include "ivcp/library.h"
#include "ivcp/sensor.h"

enum page_function{
	SENSOR_READ_CPU = 1,
	SENSOR_READ_SYS
};

static void show_welcome_title(void)
{
	printf("IVCP SDK Sample -- library version:%s\n", library_version);
	printf(">> Psensor Control Menu\n\n");
}

static void page_menu()
{
	printf("0) back\n");

	printf("%d) Read CPU Temp\n", SENSOR_READ_CPU);
	printf("%d) Read Sys1 Temp\n", SENSOR_READ_SYS);
		
	printf("\nEnter your choice: ");
}

void read_cpu_temp()
{
	mrm_err result;
	
	char temp;

	if( (result = ivcp_sensor_read_cpu_temperature( &temp )) != MRM_ERR_NO_ERROR )
	{
		printf("ivcp_sensor_read_cpu_temperature fail. error code=0x%08x\n", result);
		return;
	}
	
	printf("The CPU Temp. is %d C\n", temp);
}

void read_sys1_temp()
{
	mrm_err result;
	
	char temp;

	if( (result = ivcp_sensor_read_system_temperature1( &temp )) != MRM_ERR_NO_ERROR )
	{
		printf("ivcp_sensor_read_system_temperature1 fail. error code=0x%08x\n", result);
		return;
	}
	
	printf("The Sys Temp. is %d C\n", temp);
}

void sensor_main()
{
	int op;
	
	while(true)
	{
		CLEAR_SCREEN();
		show_welcome_title();
		page_menu();

		if( SCANF("%d", &op) <=0 )
			op = -1;

		WAIT_ENTER();

		if(op == 0)
			break;
			
		switch(op)
		{
			case SENSOR_READ_CPU:
				read_cpu_temp();
				break;
			case SENSOR_READ_SYS:
				read_sys1_temp();
				break;
			default:
				printf("Unknown choice!\n");
				break;
		}

		printf("\nPress ENTER to continue. ");
		WAIT_ENTER();

	}
}
