#include <stdio.h>

#include "common.h"
#include "sdp/library.h"
#include "sdp/sensor.h"

enum sensor_function{
	GET_LUX = 1,
};

static void show_welcome_title(void)
{
	printf("Smart Display SDK Sample -- library version:%s\n", library_version);
	printf(">> Sensor Menu\n\n");
}

void sensor_menu()
{
	printf("0) back\n");

	printf("%d) Read current LUX\n", GET_LUX);
	
	printf("\nEnter your choice: ");
}

void get_current_lux()
{
	mrm_err result;
	int lux;

	if( (result = sdp_sensor_get_lux(&lux)) != MRM_ERR_NO_ERROR )
	{
		printf("sdp_sensor_get_lux fail. error code=0x%08x\n", result);
		return;
	}

	printf("Lux is %d lux.\n", lux);
}


void sensor_main()
{
	int op;

	while(true)
	{
		CLEAR_SCREEN();
		show_welcome_title();
		sensor_menu();

		if( SCANF("%d", &op) <=0 )
			op = -1;

		WAIT_ENTER();

		if(op == 0)
			break;
			
		switch(op)
		{
			case GET_LUX:
				get_current_lux();
				break;
			default:
				printf("Unknown choice!\n");
				break;
		}

		printf("\nPress ENTER to continue. ");
		WAIT_ENTER();

	}
}
